/**
Sound is generated at setup with a triangle waveform and a simple envelope
generator. Insert your own array of notes as 'rawSequence' and let it roll.
*/
import krister.Ess.*;
AudioChannel myChannel; // Create channel
TriangleWave myWave; // Create triangle waveform
Envelope myEnvelope; // Create envelope

//int numNotes = 200; // Number of notes  /*JK-What is this??*/

//int noteDuration = /*300; // Duration of each note in milliseconds*/
float[] noteDuration = 
                      {406.250, 203.125, 203.125, 406.250, 203.125, 203.125, 406.250, 203.125, 203.125, 406.250, 
                       203.125, 203.125, 609.375, 203.125, 406.250, 406.250, 406.250, 406.250, 203.125, 203.125, 
                       203.125, 203.125, 609.375, 203.125, 406.250, 203.125, 203.125, 609.375, 203.125, 406.250, 
                       203.125, 203.125, 406.250, 203.125, 203.125, 406.250, 406.250, 406.250, 406.250, 406.250, 406.250};
float[] rawSequence = /*{ 293.6648, 293.6648, 329.62756, 329.62756, 391.995, 369.99445 , 293.6648, 293.6648,
                        329.62756, 293.6648, 439.997, 391.995, 293.6648, 293.6648, 587.3294, 493.8834,
                        391.995, 369.9945, 329.62756, 523.2516, 523.2516, 493.8834, 391.995,
                        439.997, 391.995 }; // Happy birthday */
                      {659.25511, 493.8833, 523.25113, 587.32954, 523.25113, 493.8833, 440.0, 440.0, 523.25113, 
                       659.25511, 587.32954, 523.25113, 493.8833, 523.25113, 587.32954, 659.25511, 523.25113, 
                       440.0, 440.0, 440.0, 493.8833, 523.25113, 587.32954, 698.45646, 880.0, 783.99087, 
                       698.45646, 659.25511, 523.25113, 659.25511, 587.32954, 523.25113, 493.8833, 493.8833, 
                       523.25113, 587.32954, 659.25511, 523.25113, 440.0, 440.0, 0.0};
                       //JK-instead of rest can setup a delay (equivalent to 1/4 before looping again)...at present
                       //included in notes as freq 0, duration 406.250

void setup() {
  size(100, 100);
  Ess.start(this); // Start Ess
  myChannel = new AudioChannel(); // Create a new AudioChannel
  
  //JK- calculate total time
  int totalTime = 0;
  for(int i = 0; i < noteDuration.length; i++){
    totalTime += noteDuration[i];  //get total time of array
  }
  
  //myChannel.initChannel(myChannel.frames(rawSequence.length * noteDuration)); /*JK-Gonna have to change this calculation of frames */
  myChannel.initChannel(myChannel.frames(totalTime));
  
  int current = 0;
  myWave = new TriangleWave(480, 0.3); // Create triangle wave
  EPoint[] myEnv = new EPoint[3]; // Three-step breakpoint function
  myEnv[0] = new EPoint(0, 0); // Start at 0
  myEnv[1] = new EPoint(0.25, 1); // Attack
  myEnv[2] = new EPoint(2, 0); // Release
  myEnvelope = new Envelope(myEnv); // Bind Envelope to the breakpoint function
  
  int time = 0;
  for (int i = 0; i < rawSequence.length; i++) {
    myWave.frequency = rawSequence[current]; // Update waveform frequency
    int begin = myChannel.frames(time); // Starting position within Channel
    
    //int e = int(noteDuration * 0.8); /*JK - gonna have to change this...not sure what it does.. */
    int e = int(noteDuration[i] * 0.8);
    
    int end = myChannel.frames(e); // Ending position with Channel
    myWave.generate(myChannel, begin, end); // Render triangle wave
    myEnvelope.filter(myChannel, begin, end); // Apply envelope
    current++; // Move to next note
    
    //time += noteDuration; // Increment the Channel output point  /*JK-also this... */
    time += noteDuration[i];
  }
  myChannel.play(); // Play the sound!
}

void draw() { } // Empty draw() keeps the program running

public void stop() {
  Ess.stop(); // When program stops, stop Ess too
  super.stop();
}
